#ifndef MYX_REDIS_CONTAINERS_HPP_
#define MYX_REDIS_CONTAINERS_HPP_

#pragma once

#include <myx/base/config.hpp>

#include <QByteArrayList>
#include <QVariantList>

namespace myx {

namespace redis {

static const QByteArray Separator { "\r\n" }; //!< Строковый разделитель слов во фразе

QByteArray array( const QVariantList& parts );
QByteArrayList split( const QByteArray& buffer, int* splitLength = nullptr );
// QByteArray part( const QVariant& value );
// QByteArray packHash( const QVariantHash& hash );
// QVariantHash unpackHash( const QByteArray& message );
// QByteArray packList( QByteArrayList list );
// QByteArray packList( const QVariantList& list );
QVariantList unpackList( const QByteArray& message );
// template< typename T >
// QByteArray packPair( T first, T second );
// template< typename T1, typename T2 >
// QByteArray packPair( T1 first, T2 second );
// template< typename T >
// std::pair< T, T > unpackPair( const QByteArray& message );
// template< typename T1, typename T2 >
// std::pair< T1, T2 > unpackPair( const QByteArray& message );

} // namespace redis

} // namespace myx

#include <myx/redis/containers.tpp>

#ifdef MYXLIB_HEADER_ONLY
#include "containers-inl.hpp"
#endif

#endif // ifndef MYX_REDIS_CONTAINERS_HPP_
